

#include <ESP8266WiFi.h>

ADC_MODE(ADC_VCC);

const char* ssid = "YOUR WIFI SSID";
const char* password = "YOUR WIFI PASSWORD";

const int httpPort = 80;

//variable to hold battery voltage read from esp adc pin with ADC_MODE(ADC_VCC) set above 
double voltage = 0.0;

// change server to your email server ip or domain
// IPAddress server( 1, 2, 3, 4 );
char server[] = "aspmx.l.google.com";  // mail server, this one i for gmail https://support.google.com/a/answer/176600?hl=en

  WiFiClient client;


void setup() {
  //Serial.begin(115200);
  delay(10);

  // We start by connecting to a WiFi network

  //Serial.println();
  //Serial.println();
  //Serial.print("Connecting to ");
  //Serial.println(ssid);
  
  WiFi.begin(ssid, password);
  
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    //Serial.print(".");
  }

  //Serial.println("");
  //Serial.println("WiFi connected");  
  //Serial.println("IP address: ");
  //Serial.println(WiFi.localIP());

  //from mail send
  delay(2000);
  //Serial.println(F("Ready."));
}

void loop() {
voltage = ESP.getVcc();
voltage = voltage/1000;

  
    if(sendEmail()){
      //Serial.println(F("Email sent"));
      
      //Serial.print("voltage: ");
      //Serial.println(voltage);
      delay(60000);     // Delay for 1 minut to avoid multiable emails 
      ESP.deepSleep(100, WAKE_RF_DEFAULT);  //Sleep until GPIO16 is set to RESET
    }
    else{ 
      //Serial.println(F("Email failed"));
    }
  


}//end loop 



byte sendEmail()
{
  byte thisByte = 0;
  byte respCode;

  if(client.connect(server,25)) {
    //Serial.println(F("connected"));
  } else {
    //Serial.println(F("connection failed"));
    return 0;
  }

  if(!eRcv()) return 0;

// change to your public ip
  client.println(F("helo 1.2.3.4"));

  if(!eRcv()) return 0;
  //Serial.println(F("Sending From"));

// change to your email address (sender)
  client.println(F("MAIL From: <YOURMAIL@gmail.com>"));

  if(!eRcv()) return 0;

// change to recipient address
  //Serial.println(F("Sending To"));
  client.println(F("RCPT To: <YOURMAIL@gmail.com>"));

  if(!eRcv()) return 0;

  //Serial.println(F("Sending DATA"));
  client.println(F("DATA"));

  if(!eRcv()) return 0;

  //Serial.println(F("Sending email"));

// change to recipient address
  client.println(F("To: You <YOURMAIL@gmail.com>"));

// change to your address
  client.println(F("From: Postchecker <YOURMAIL@gmail.com>"));

  client.println(F("Subject: POST!\r\n"));

  client.println(F("Så er der blevet puttet noget i postkassen!!!"));
  //Send batterispænding med
  client.print(F("Batteri spænding: "));
  client.print(voltage);
  client.println(F(" Volt"));

  if(voltage < 2.5){
      //Serial.println(F("Batterispænding er LAV, oplad batterier!!!!"));
      client.println(F("Batterispænding er LAV, oplad batterier!!!!"));
  }

  client.println(F("."));

  if(!eRcv()) return 0;

  //Serial.println(F("Sending QUIT"));
  client.println(F("QUIT"));

  if(!eRcv()) return 0;

  client.stop();

  //Serial.println(F("disconnected"));

  return 1;
}

byte eRcv()
{
  byte respCode;
  byte thisByte;
  int loopCount = 0;

  while(!client.available()) {
    delay(1);
    loopCount++;

    // if nothing received for 10 seconds, timeout
    if(loopCount > 10000) {
      client.stop();
      //Serial.println(F("\r\nTimeout"));
      return 0;
    }
  }

  respCode = client.peek();

  while(client.available())
  {  
    thisByte = client.read();    
    //Serial.write(thisByte);
  }

  if(respCode >= '4')
  {
    efail();
    return 0;  
  }

  return 1;
}


void efail()
{
  byte thisByte = 0;
  int loopCount = 0;

  client.println(F("QUIT"));

  while(!client.available()) {
    delay(1);
    loopCount++;

    // if nothing received for 10 seconds, timeout
    if(loopCount > 10000) {
      client.stop();
      //Serial.println(F("\r\nTimeout"));
      return;
    }
  }

  while(client.available())
  {  
    thisByte = client.read();    
    //Serial.write(thisByte);
  }

  client.stop();

  //Serial.println(F("disconnected"));
}
